/*
  Ping turret navigation with diagonally facing IRs and music player selection.
  Version 0.2a: Underdocummented, unpolished and wholly unsuitable for sharing.
  By: Zywack
*/

#include "simpletools.h"                      // Include simple tools
#include "sirc.h"
#include "ping.h"
#include "wavplayer.h"                       
#include "abdrive.h"                          
#include "servo.h"

int previousAngle, angleCount, previousDistance, distanceCount, stuckCounter, shiftLeftCount, shiftRightCount;

int main()                                    // main function
{
  freqout(4, 2000, 2000);                      // Reset indicator
  low(26);                                      // D/A0 & D/A1 to 0 V
  low(27);
  sirc_setTimeout(50);                      // -1 if no remote code in 1 s
  int DO = 22, CLK = 23, DI = 24, CS = 25;     // SD I/O pins
  sd_mount(DO, CLK, DI, CS);                   // Mount SD card
  wav_volume(6);                              // Set volume here, 1-10
  servo_angle(16, 900);

  int distance;
  stuckCounter = 0;
  distanceCount = 0;
  previousAngle = -1;
  previousDistance = 0;
  shiftLeftCount = 0;
  shiftRightCount = 0;

  while(1)                                    // Repeat indefinitely
  {          
    int irbutton = musicCheck();       
    drive_speed(50, 50);
    distance = ping_cm(17);                    // Get cm distance from Ping)))
    if (distance == previousDistance) {
      distanceCount = distanceCount + 1;
      if (distanceCount >= 10) {
        // Distance similar for 10 loops, probably stuck on low object...
        distanceCount = 0;
        drive_goto(-20,-20);
        if (rand() % 2 == 1) {
          drive_goto(30,-30);
        }
        else {
          drive_goto(-30,30);
        }     
      }
    }
    else {
      distanceCount = 0;
    }
    previousDistance = distance;

    if (distance < 25) {
      drive_speed(0, 0);
      int angle = panCheck();
      
      if (angle == -1) {
        drive_goto(-15,-15);
        drive_goto(40,-38);
        stuckCounter = 0;
      }
      else {
        stuckCounter = stuckCounter + 5;
        float tempFloat = 0;
        int tempInt = 0;
        
        if (angle >= 900) {
          angle = angle - 900;
          tempFloat = ((51.0 * (angle / 900.0)));
          tempInt = (tempFloat);
          drive_goto(0,tempInt);          
        }
        else {
          tempFloat = (51 - (51.0 * (angle / 900.0)));
          tempInt = (tempFloat);
          drive_goto(tempInt,0);
        }
      }
    }

    if (stuckCounter >= 10) {
// Had to pan constantly in short amount of time, not finding any viable angle to go to.
      drive_goto(-15,-15);
      drive_goto(40,-38);
      stuckCounter = 0;
    }
          

// IR light block navigation verifications
    freqout(11, 1, 38000);                      // Left IR LED light
    int irLeft = input(10);                         // Check left IR detector

    freqout(1, 1, 38000);                       // Repeat for right detector
    int irRight = input(2);

    if (irLeft == 0) {
      while (irLeft == 0) { 
        drive_goto(-10,-10);
        drive_goto(20,0);
        freqout(11, 1, 38000);                      // Left IR LED light
        irLeft = input(10);  
        shiftRightCount = shiftRightCount + 6;
      }
    }
    if (irRight == 0) {
      while (irRight == 0) {
        drive_goto(-10,-10);
        drive_goto(0,20);
        freqout(1, 1, 38000);                      // Right IR LED light
        irRight = input(2);  
        shiftLeftCount = shiftLeftCount + 6;
      }
    }

    if ((shiftRightCount > 10) && (shiftLeftCount > 10)) {
// IR keeps shifting vehicle left and right due to objects on both sides.
// Could potentially try to "force ahead" with ping only, but could get stuck on the sides.
// Risky without any accelerometer, bumper or similar, so
// shift back to center position, back away a little, turn around.
      drive_goto(-10,-10);
      drive_goto(10,0);
      drive_goto(60,-59);
      shiftLeftCount = 0;
      shiftRightCount = 0;
    }
    if (stuckCounter > 0) {
      stuckCounter = stuckCounter - 1;
    }
    if (shiftLeftCount > 0) {
      shiftLeftCount = shiftLeftCount - 1;
    } 
    if (shiftRightCount > 0) {
      shiftRightCount = shiftRightCount - 1;
    } 
    pause(50);                                 // Pause before repeating
   
  }
}

int panCheck() {
  int counter = 0;
  int currentPan = 0;
  int maxDistance = 0;
  int curDistance = 0;
  servo_angle(16, counter);
  pause(400);
//  print("%c",CLS);
  while (counter <= 1800) {
    servo_angle(16, counter);
    curDistance = ping_cm(17);
//    print("%c Angle = %d   Distance = %d", CRSRDN, counter, curDistance);
    if ((curDistance < 80) && (curDistance > maxDistance)) {
      maxDistance = curDistance;
      currentPan = counter;
    }
    counter = counter + 50;  
    pause(20);  
  }
  servo_angle(16, 900);
  pause(400);
//  print("%c Angle final = %d   Distance = %d", CRSRDN, currentPan, maxDistance);
  if (maxDistance > 25) {
    return currentPan;
  }
  else {
    return -1;
  }
}


int musicCheck() {
    int irbutton = sirc_button(6);
    if (irbutton != -1) {
      if (irbutton == 1) {                       
        wav_play("maria.wav");                  
      }
     else if (irbutton == 2) {                       
        wav_play("leiliana.wav");                  
      }
     else if (irbutton == 3) {
        wav_play("mana.wav");
      }
     else if (irbutton == 4) {
        wav_play("ogre.wav");
      }
     else if (irbutton == 0) {
        wav_stop();
      }
    }
    return irbutton;
}
